"use strict";
var http_1 = require("@angular/http");
var ProgressBrowserXhr = (function (_super) {
    __extends(ProgressBrowserXhr, _super);
    function ProgressBrowserXhr(upload, download) {
        if (upload === void 0) { upload = null; }
        if (download === void 0) { download = null; }
        var _this = _super.call(this) || this;
        _this.upload = upload;
        _this.download = download;
        return _this;
    }
    ProgressBrowserXhr.prototype.build = function () {
        var xhr = _super.prototype.build.call(this);
        if (this.upload) {
            xhr.upload.addEventListener("progress", this.createProgressListener(this.upload));
        }
        if (this.download) {
            xhr.addEventListener("progress", this.createProgressListener(this.download));
        }
        return xhr;
    };
    ProgressBrowserXhr.prototype.createProgressListener = function (listener) {
        return function (event) {
            var progress = {
                event: event,
                lengthComputable: event.lengthComputable,
                loaded: event.loaded
            };
            if (event.lengthComputable) {
                progress.total = event.total;
                progress.percentage = Math.round((event.loaded * 100 / event.total));
            }
            listener(progress);
        };
    };
    ProgressBrowserXhr.create = function (upload, download) {
        return new ProgressBrowserXhr(upload, download);
    };
    return ProgressBrowserXhr;
}(http_1.BrowserXhr));
exports.ProgressBrowserXhr = ProgressBrowserXhr;
//# sourceMappingURL=ProgressBrowserXhr.js.map