import { Http, ConnectionBackend, RequestOptions, ResponseOptions, XSRFStrategy } from "@angular/http";
import { HttpWithDownloadProgressListener, HttpWithUploadProgressListener, Progress } from "./interfaces";
export declare class ProgressHttp extends Http implements HttpWithUploadProgressListener, HttpWithDownloadProgressListener {
    protected _defaultResponseOptions: ResponseOptions;
    protected _xsrfStrategy: XSRFStrategy;
    private _uploadCallback;
    private _downloadCallback;
    constructor(backend: ConnectionBackend, defaultOptions: RequestOptions, _defaultResponseOptions: ResponseOptions, _xsrfStrategy: XSRFStrategy);
    withDownloadProgressListener(listener: (progress: Progress) => void): HttpWithDownloadProgressListener;
    withUploadProgressListener(listener: (progress: Progress) => void): HttpWithUploadProgressListener;
    private _buildProressHttpInstance();
}
