"use strict";
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
var ProgressBrowserXhr_1 = require("./ProgressBrowserXhr");
var ProgressHttp = ProgressHttp_1 = (function (_super) {
    __extends(ProgressHttp, _super);
    function ProgressHttp(backend, defaultOptions, _defaultResponseOptions, _xsrfStrategy) {
        var _this = _super.call(this, backend, defaultOptions) || this;
        _this._defaultResponseOptions = _defaultResponseOptions;
        _this._xsrfStrategy = _xsrfStrategy;
        _this._uploadCallback = null;
        _this._downloadCallback = null;
        return _this;
    }
    ProgressHttp.prototype.withDownloadProgressListener = function (listener) {
        this._downloadCallback = listener;
        return this._buildProressHttpInstance();
    };
    ProgressHttp.prototype.withUploadProgressListener = function (listener) {
        this._uploadCallback = listener;
        return this._buildProressHttpInstance();
    };
    ProgressHttp.prototype._buildProressHttpInstance = function () {
        var backend = new http_1.XHRBackend(ProgressBrowserXhr_1.ProgressBrowserXhr.create(this._uploadCallback, this._downloadCallback), this._defaultResponseOptions, this._xsrfStrategy);
        var http = new ProgressHttp_1(backend, this._defaultOptions, this._defaultResponseOptions, this._xsrfStrategy);
        http._uploadCallback = this._uploadCallback;
        http._downloadCallback = this._downloadCallback;
        return http;
    };
    return ProgressHttp;
}(http_1.Http));
ProgressHttp = ProgressHttp_1 = __decorate([
    core_1.Injectable(),
    __metadata("design:paramtypes", [http_1.ConnectionBackend,
        http_1.RequestOptions,
        http_1.ResponseOptions,
        http_1.XSRFStrategy])
], ProgressHttp);
exports.ProgressHttp = ProgressHttp;
var ProgressHttp_1;
//# sourceMappingURL=progress-http.service.js.map